package org.dromara.payment.invoice.controller;

import java.util.List;

import lombok.RequiredArgsConstructor;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.constraints.*;
import cn.dev33.satoken.annotation.SaCheckPermission;
import org.dromara.common.satoken.utils.LoginHelper;
import org.dromara.system.api.model.LoginUser;
import org.springframework.web.bind.annotation.*;
import org.springframework.validation.annotation.Validated;
import org.dromara.common.idempotent.annotation.RepeatSubmit;
import org.dromara.common.log.annotation.Log;
import org.dromara.common.web.core.BaseController;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.core.domain.R;
import org.dromara.common.core.validate.AddGroup;
import org.dromara.common.core.validate.EditGroup;
import org.dromara.common.log.enums.BusinessType;
import org.dromara.common.excel.utils.ExcelUtil;
import org.dromara.payment.invoice.domain.vo.MerInvoiceAddressVo;
import org.dromara.payment.invoice.domain.bo.MerInvoiceAddressBo;
import org.dromara.payment.invoice.service.IMerInvoiceAddressService;
import org.dromara.common.mybatis.core.page.TableDataInfo;

/**
 * 发票地址
 * 前端访问路由地址为:/payment/invoiceAddress
 *
 * @author LionLi
 * @date 2024-05-06
 */
@Validated
@RequiredArgsConstructor
@RestController
@RequestMapping("/invoiceAddress")
public class MerInvoiceAddressController extends BaseController {

    private final IMerInvoiceAddressService merInvoiceAddressService;

    /**
     * 查询发票地址列表
     */
    //@SaCheckPermission("payment:invoiceAddress:list")
    @GetMapping("/list")
    public TableDataInfo<MerInvoiceAddressVo> list(MerInvoiceAddressBo bo, PageQuery pageQuery) {
        LoginUser loginUser = LoginHelper.getLoginUser();
        bo.setMerId(loginUser.getBusId().longValue());
        return merInvoiceAddressService.queryPageList(bo, pageQuery);
    }

    /**
     * 导出发票地址列表
     */
    @SaCheckPermission("payment:invoiceAddress:export")
    @Log(title = "发票地址", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(MerInvoiceAddressBo bo, HttpServletResponse response) {
        List<MerInvoiceAddressVo> list = merInvoiceAddressService.queryList(bo);
        ExcelUtil.exportExcel(list, "发票地址", MerInvoiceAddressVo.class, response);
    }

    /**
     * 获取发票地址详细信息
     *
     * @param id 主键
     */
    @SaCheckPermission("payment:invoiceAddress:query")
    @GetMapping("/{id}")
    public R<MerInvoiceAddressVo> getInfo(@NotNull(message = "主键不能为空")
                                     @PathVariable Long id) {
        return R.ok(merInvoiceAddressService.queryById(id));
    }

    /**
     * 新增发票地址
     */
    //@SaCheckPermission("payment:invoiceAddress:add")
    @Log(title = "发票地址", businessType = BusinessType.INSERT)
    @RepeatSubmit()
    @PostMapping()
    public R<Void> add(@Validated(AddGroup.class) @RequestBody MerInvoiceAddressBo bo) {
        LoginUser loginUser = LoginHelper.getLoginUser();
        bo.setMerId(loginUser.getBusId().longValue());
        bo.setMerNo(loginUser.getBusNo());
        bo.setAddBy(loginUser.getNickname());
        return toAjax(merInvoiceAddressService.insertByBo(bo));
    }

    /**
     * 修改发票地址
     */
    //@SaCheckPermission("payment:invoiceAddress:edit")
    @Log(title = "发票地址", businessType = BusinessType.UPDATE)
    @RepeatSubmit()
    @PutMapping()
    public R<Void> edit(@Validated(EditGroup.class) @RequestBody MerInvoiceAddressBo bo) {
        LoginUser loginUser = LoginHelper.getLoginUser();
        bo.setMerId(loginUser.getBusId().longValue());
        return toAjax(merInvoiceAddressService.updateByBo(bo));
    }

    /**
     * 删除发票地址
     *
     * @param ids 主键串
     */
    @SaCheckPermission("payment:invoiceAddress:remove")
    @Log(title = "发票地址", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public R<Void> remove(@NotEmpty(message = "主键不能为空")
                          @PathVariable Long[] ids) {
        return toAjax(merInvoiceAddressService.deleteWithValidByIds(List.of(ids), true));
    }
}
